'use strict';

const Controller = require('egg').Controller;

// 字典
class DictController extends Controller {

  constructor(ctx) {
    super(ctx);
    // 特殊的入参校验可以重写在这，默认可以使用commonRule
    ctx.logger.debug('构造');
  }

  // 字典表查询
  async index() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate({});
    // 调用 Service 进行业务处理
    const data = await service.dictService.index(payload);
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

  // 省份城市
  async place() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    const data = await service.dictService.place();
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }


  // 消息类型
  async msgType() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    const data = await service.dictService.msgType();
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

  // 车系车型
  async car() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    const data = await service.dictService.car(ctx.validate({}));
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }


  // 远控失败类型
  async rcFailType() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    const data = await service.dictService.rcFailType();
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

  // 自动化测试流程id
  async autoTest() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    const data = await service.dictService.autoTest();
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

}

module.exports = DictController;
