﻿'use strict';

const Controller = require('egg').Controller;
// 在线用户统计分析管理
class OnlineUserController2 extends Controller {

  // 在线用户总数
  async index() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    const data = await service.onlineUserService2.index(payload);
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }


  // 在线用户区域分布 => APP
  async appPlace() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理 { startTime: 1587859200000, endTime: 1587859200001 }
    const data = await service.onlineUserService2.place('appPlace');
    // 设置响应内容和响应状态码
    ctx.success({ data });

  }


  // 在线用户区域分布 => T-BOX
  async tBoxPlace() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理 { startTime: 1576684800000, endTime: 1576771200000 }
    const data = await service.onlineUserService2.place('tBoxPlace');
    // 设置响应内容和响应状态码
    ctx.success({ data });

  }

  // 在线用户 扩展信息
  async ext() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    const data = await service.onlineUserService2.ext();
    // 设置响应内容和响应状态码
    ctx.success({ data });

  }


}

module.exports = OnlineUserController2;
