'use strict';

const Controller = require('egg').Controller;
// 暂定规范：(根据实际情况进行调整)
// 前期所有业务通过controller调用对应service获取即时计算数据   后期建立定时任务调用所有的业务的service，定时传入当日时间戳（type只会是日维度 0 ）进行计算，
// 然后调用统计service进行统计表数据插入，统一替换全部contoller的业务为统计表的查找service
// 理论上  router(23个br) = > controller (每个br对应的子业务即接口 )   (router + controller)    >>>
// (service + model) service(业务对应主表的service,调用主表的Model，和其他表的Model) =>Model

// 平台用户统计模块
class UserController extends Controller {

  // 用户总数
  async index() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    const data = await service.tRbacUserService.index(payload);
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

  // 用户增量
  async increment() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    const data = await service.tRbacUserService.index(payload, 'newTotal');
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }


  // 实销用户总数
  async saled() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    const data = await service.tVehicleRecordService2.saledUser(payload);
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

  // 实销额外
  async saledExt() {
    const { ctx, service } = this;
    // 调用 Service 进行业务处理
    const data = await service.tVehicleRecordService2.saledExt();
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

  // 车主  用户性别和年龄
  async sexAndAge() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    const data = await service.tRbacUserService.sexAndAge();
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }

  // 实销增量
  async register() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    const data = await service.tVehicleRecordService2.register(payload);
    // 设置响应内容和响应状态码
    ctx.success({ data });
  }


}

module.exports = UserController;
