'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlLocalDB');
  // ivi功能 本地清洗 数据结构
  const IviBehaciorRecordSchema = new Schema({
    create_date: { type: Number }, // 统计的数据是哪一天的
    year: { type: Number }, // 年 统计的数据
    month: { type: Number }, // 月 统计的数据
    day: { type: Number }, // 日 统计的数据
    dateString: { type: String }, // 时间字符串  yyyy-MM-dd
    start_time: { type: Date }, // 开始统计时间
    end_time: { type: Date, default: Date.now }, // 结束统计时间
    total: { type: Number }, // 当天驾驶里程次数
    musicTotal: { type: Number }, // 听歌里程次数
    fwTotal: { type: Number }, // 电台里程次数
    newsTotal: { type: Number }, // 新闻里程次数
    videoTotal: { type: Number }, // 视频 里程次数

  });
  IviBehaciorRecordSchema.index({ create_date: -1 });
  return conn.model('IviBehaciorRecord', IviBehaciorRecordSchema, 'lc_ivi_behacior_record');
};
