'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlLocalDB');
  // 统计表    ==  按日进行  整体业务的统计  二次清洗表
  const StatisticsSchema = new Schema({
    create_date: { type: Number }, // 统计的数据是哪一天的
    year: { type: Number }, // 年 统计的数据
    month: { type: Number }, // 月 统计的数据
    day: { type: Number }, // 日 统计的数据
    msg: { type: String }, // 统计结果
    type: { type: String }, // 任务类型
    start_time: { type: Date }, // 开始统计时间
    end_time: { type: Date, default: Date.now }, // 结束统计时间
  });
  StatisticsSchema.index({ create_date: -1 });
  return conn.model('Statistics', StatisticsSchema, 'statistics');
};
