'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlLocalDB');
  // TBOX自动测试  数据结构
  const TBoxAutoTestingStatsSchema = new Schema({
    create_date: { type: Number }, // 统计的数据是哪一天的
    year: { type: Number }, // 年 统计的数据
    month: { type: Number }, // 月 统计的数据
    day: { type: Number }, // 日 统计的数据
    dateString: { type: String }, // 时间字符串  yyyy-MM-dd
    start_time: { type: Date }, // 开始统计时间
    end_time: { type: Date, default: Date.now }, // 结束统计时间

    autoTest: [
      {
        _id: { type: String }, // 流程id
        data: [
          {
            applicationId: { type: String }, // 流程名称
            count: { type: Number }, // 总数
            failCount: { type: Number }, // 失败数
          },
        ],
      },
    ],
  });
  TBoxAutoTestingStatsSchema.index({ create_date: -1 });
  return conn.model('TBoxAutoTestingStats', TBoxAutoTestingStatsSchema, 'lc_t-box_auto_testing_stats');
};
