'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlDB');
  // t-box在线数据结构   车辆在线可以参考这个表的数据
  const TBoxOnlineSchema = new Schema({
    _id: { type: String }, // 主键，年月日 + 车辆vin
    vin: { type: String }, // 车辆VIN
    series_code: { type: String }, // 车系编码
    series_name: { type: String }, // 车系名称
    online_time: { type: Number }, // TBox上线时间戳

  });
  TBoxOnlineSchema.index({ online_time: -1 });
  TBoxOnlineSchema.index({ online_time: -1, vin: -1 });
  return conn.model('TBoxOnline', TBoxOnlineSchema, 't-box_online_info');
};
