'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlDB');
  // 区 数据结构
  const TSyncCountySchema = new Schema({
    _id: { type: String }, // Objectid
    out_county_code: { type: String }, // 区县代码
    county_name: { type: String }, // 区县名称
    out_city_code: { type: String }, // 城市代码
    city_name: { type: String }, // 城市名称
    out_pro_code: { type: String }, // 省份代码
    province_name: { type: String }, // 省份名称
    area_code: { type: String }, // 地区代码
    area_name: { type: String }, // 地区名称
    country_short_name: { type: String }, // 国家代码
    country: { type: String }, // 国家名称
    stop_sign: { type: String }, //
    stop_date: { type: String }, //
  });

  TSyncCountySchema.index({ province_name: -1 });
  TSyncCountySchema.index({ out_pro_code: -1 });
  return conn.model('TSyncCounty', TSyncCountySchema, 't_sync_county');
};
